# Exploring the Implementation of a Simple REST API Front End

## Content Learning Objectives


_After completing this activity, students should be able to:_

*

## Process Skill Goals

_During the activity, students should make progress toward:_

*

## Team Roles

_Decide what role each of you will play for today. Choose a role that you have not played before, or recently. The goal should be to have all team members rotate through the roles on a regular basis to become comfortable with all the roles. If you have only three people, one should have two roles. If you have five people, two may share the same role. Record role assignments here._


<table>
  <tr>
   <td>
Manager
   </td>
   <td>
   </td>
  </tr>
  <tr>
   <td>Presenter
   </td>
   <td>
   </td>
  </tr>
  <tr>
   <td>Recorder
   </td>
   <td>
   </td>
  </tr>
  <tr>
   <td>Technician/
<br>
Reflector
   </td>
   <td>
   </td>
  </tr>
</table>

1. Pull changes for [Microservices Example](https://gitlab.com/LibreFoodPantry/training/microservices-example) project.
2. Run simple front end
   * Temporary steps. These shouldn't be necessary, but until I figure out what is wrong with my `shell/ng-serve` command, you need to run `shell/run` first and exit.
      * `shell/run`
      * `exit`
   1. `shell/ng-serve`
   2. `cd OrderModule/ListItemsWebUI`
   3. `yarn install`
   4. `ng serve --host 0.0.0.0`
   5. When it tells you to, open your browser to `http://localhost:4200`
3. `ListItemsWebUI` is an [Angular](http://angular.io) application.
4. Look inside the `ListItemsWebUI` directory. 
   * Most of the files here were generated by the Angular CLI using the command `ng new ListItemsWebUI`. (Actually all of them were generated by the Angular CLI, but some in subdirectories were skeletons generated later using other `ng` commands.)
   * `e2e` contains skeleton code for end-to-end testing
   * `node_modules` contains all of the installed node modules for the app. This is included in the `.gitignore` file, so the node modules are not committed.
   * `src` contains the code we will modify for the app.
   * The remaining files are all configuration files for Angular, the Karma test framework, Node, or the TypeScript transpiler.
   * At the top level, none of these files were modified.
5. Look inside the `src` sub-directory. None of the top-level files were modified either.
6. Look inside the `app` subdirectory.
7. Open the `index.html` file.
   * This is the main page for the web app.
   * This file was generated when the app was generated with the `ng new` command.
   * It has not been modified.
   * Find the body section of the file. The body is where you would normally add HTML code to define the structure of the page.
   * Note that is contains a single beginning and end tag: `<app-root></app-root>`
   * This is a custom tag (not standard HTML) created by Angular.
   * When the Angular app is built (which was done when you ran `ng serve`) this tag is replaced with the HTML in the root component (`app-component`).
8. All of the `app.component.*` files and the `app.module.ts` file were generated when creating the new app. Some were modified.
   1. How many `app-component.*` files are there?
   2. List their names.
9. Open `app.component.html`
   * This file was generated, and then modified.
   1. What is the purpose of the section within the `<style></style>` tags?
   2. Find where the toolbar is defined. How did you find it?
   3. Find the where the logo is added. Where does the logo file exist in the project?
   4. Find where the welcome text is given in the banner. Make a change to the banner text, and save the file. Go to your browser to view the change.
   5. What is in the `<div class="content" role="main">` section? Paste it here.
   6. What do you think it represents?
   7. Where do you think the code to implement it resides?
10. Open `app.component.css`. What do you think should be in this file?
11. Open `app.component.ts`.
    1. What is in this file?
    2. What is the `selector` used for?
    3. What is the `templateUrl` used for?
    4. What is the `styleUrls` used for?
12. All Angular app components are composed of 3 files - one that specifies the structure of the component, one that specifies the styling of the component, and one the specifies the behavior of the component.
    1. Which file specifies the structure?
    2. Which file specifies the styling?
    3. Which file specifies the behavior?
13. There is a 4th file here (`app.component.spec.ts`) which contains tests for the component.
14. Why it `app.component.css` empty, yet it is not plain-looking?
    1. Open `app.component.html` and cut the text between the `<style></style>` tags *(don't just delete it, you are going to want it back...)* then save the file.
    2. Check your browser. What changed?
    3. Open `app.component.css` and paste in the text you cut from `app.component.html`. Save the file.
    4. Check your browser. What changed?
15. The `list-items` component was generated with the `ng generate component list-items` command.
    1. It created the `list-items` subdirectory and the files inside.
    2. It added the `ListItemsComponent` to the `app.module.ts` file. 
       1. Open the `app.module.ts` files.
       2. Find all the lines you think were added when the `ListItemsComponent` was created. List their line numbers and what you think they do.
16. Open the `list-items` subdirectory.
    1. How many files are there?
    2. What are their names?
    3. Is this what you expected to find?
17. Open `list-items.component.html`
    1. Compare the HTML in the file to the page you see in your browser. Match the parts.
    2. What is happening in lines 3-7 (in general terms) based on what you saw in your browser?
    3. Look at line 3.
       1. What does look like that you are familiar with?
       2. What is `item` used for in this line?
       3. Where do you think `itemsList` might come from?
    4. Look at line 5.
       1. What is this doing?
       2. What do you think the `{{}}` around `item` is there for?
       3. Try taking out the `{{}}` and saving the file. Check you browser to see what has happened.
       4. Restore the `{{}}` and save the file.
18. Open `list-items.component.ts`.
    1. Find `itemsList` that was used in the `list-items.component.html` file. 
       1. Where is is declared?
       2. What is its type?
       3. What is its initial value?
    2. Find the function where `itemsList` receives a value.
       1. Where do the `items` come from?
       2. When do you think this function is called? Why?
       3. Why do you think `.subscribe` is there?
       4. What do you think `listItemsService` must do?
19. `list-items.service.ts` was generated by the `ng generate service list-items` command.
    1. Open `list-items.service.ts`.
    2. Why do you think this code is not making an HTTP `GET` request to `place-order-api`?
    3. What do you think is the next step for this service?
20. What do you think is the next step for this web app?

---

&copy; 2020 Karl R. Wurst <karl@w-sts.com>

<img src="http://mirrors.creativecommons.org/presskit/buttons/88x31/png/by-sa.png" width=100px/>This work is licensed under the Creative Commons Attribution-ShareAlike 4.0 International License. To view a copy of this license, visit [http://creativecommons.org/licenses/by-sa/4.0/]() or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.